﻿using PDF_Office.Model;
using Prism.Commands;
using Prism.Mvvm;
using Prism.Services.Dialogs;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PDF_Office.ViewModels.Dialog.BOTA
{
    public class AddBookmarkDialogViewModel : BindableBase, IDialogAware
    {
        public string Title => "";

        public event Action<IDialogResult> RequestClose;

        private string mark;

        public string Mark
        {
            get { return mark; }
            set
            {
                SetProperty(ref mark, value);
            }
        }

        public DelegateCommand CancelCommand { get; set; }

        public DelegateCommand CreateCommnad { get; set; }

        public AddBookmarkDialogViewModel()
        {
            CancelCommand = new DelegateCommand(CancelEvent);
            CreateCommnad = new DelegateCommand(CreateEvent);
        }

        private void CreateEvent()
        {
            DialogParameters valuePairs = new DialogParameters();
            valuePairs.Add(ParameterNames.Bookmark, Mark);
            RequestClose.Invoke(new DialogResult(ButtonResult.OK, valuePairs));
        }

        private void CancelEvent()
        {
            RequestClose.Invoke(new DialogResult(ButtonResult.Cancel));
        }

        public bool CanCloseDialog()
        {
            return true;
        }

        public void OnDialogClosed()
        {
            return;
        }

        public void OnDialogOpened(IDialogParameters parameters)
        {
            return;
        }
    }
}